#include "render.h"

//Some useful global handles
NativeWindowType hNativeWnd = 0; // A handle to the window we will create.
GLboolean drawInOrtho = GL_TRUE; //This variable will change with every click in the touch screen of the pda

/*This is the main function. Here we will create the rendering window, initialize OpenGL ES, write the message loop, and, at the end, clean all and release all used resources*/
int main() 
{
  // Initialize native OS
  OS_InitFakeOS();
  GLboolean done = GL_FALSE; 
	  
  // Create native window.
  hNativeWnd = OS_CreateWindow();	                  
  if(!hNativeWnd) return GL_FALSE;
  
  if(!InitOGLES()) return GL_FALSE; //OpenGL ES Initialization
  
 
  unsigned int startTime = OS_GetTickCount();
  
  //Message Loop
  //while(!done)
  for(int i=0;i<500;i++)
  {
     Render();
      
  	__int64 interval = (__int64)(OS_GetTickCount())-(__int64)startTime;
  	
  	if(interval < 0)
  		interval *= -1;
    
    if( interval > 5000 )
  	{
  		if( drawInOrtho )
  		{
  			SetOrtho();
  			drawInOrtho = GL_FALSE;
  		}
  		else
  		{
  			SetPerspective();
  			drawInOrtho = GL_TRUE;	
  		}
  		startTime = OS_GetTickCount();  		
  	}	 
  }
  
  //Clean up all
  Clean();
 
  return 0;
}
