#define	lf_linux
#define	__int64	long long

#include <stdio.h>
#include <unistd.h>
#include <sys/mman.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>

#include "render.h"
#include <sys/time.h>
#include "GLES/libogl.h"

#include <stdio.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>


#define MLC_WIZ 1

//#include "common.h"
#ifndef MLC_WIZ 
#include "mlc_ioctl.h"
#else
#include "pollux_fb_ioctl.h"
#endif


//#include "formats.h"
//#include "mlc.h"


#define VID_RGBFMT_R5G6B5       0x4432
 
#include <iostream>

using namespace std;

void OS_InitFakeOS( void) 
{
}

NativeWindowType OS_CreateWindow() { return (NativeWindowType)malloc( 16*1024);}

int OS_GetTickCount( void) {
#define	SCALE	100
struct timeval time;

    gettimeofday( &time, 0);
    return (time.tv_sec*SCALE+time.tv_usec/(1000000/SCALE));
}

extern void GLESOAL_GetWindowSize( int* pWidth, int* pHeight );
void OS_GetWindowSize( NativeWindowType hNativeWnd, int* width, int* height) 
{
    GLESOAL_GetWindowSize( width, height );
}

#define P_3DE		2
#define	DEV_NAME	"/dev/ga3d"
#define	MEM_NAME	"/dev/mem"
#define	PHYS_ADDR	0xc001a000

static int   fd_mem;
static int   fd_dev;

static void* p3DE = NULL;
static int   len3DE;

static void* mem1 = NULL;
#define	MEM1_PHYS	0x03000000
#define	mem1size	0x00800000
#define	mem1virt	(void*)0xb1000000

static void* mem2 = NULL;
#define	MEM2_PHYS	( MEM1_PHYS + mem1size)
#define	mem2size	mem1size
#define	mem2virt	(void*)((unsigned int)mem1virt + mem1size)

static int FSAAval;

#ifndef MLC_WIZ

static int layer3Deven, layer3Dodd, layer3D;
#define	L3Deven	"/dev/layer0"
#define	L3Dodd	"/dev/layer1"
#define	L3D	"/dev/layer0"

#else
static FB_RGBSET rgbset;
static unsigned int DevEnable[3];	
static int fb_fd;
#define FB_DEV_PATH "/dev/fb0"
#endif



GLESOALbool GLESOAL_Initalize( ___OAL_MEMORY_INFORMATION__* pMemoryInfomation, int FSAAEnb)
{
	int psize = getpagesize();
	int xlayer;

#ifndef MLC_WIZ
	// Open MLC layer drivers -- 2 layers for FSAA mode, 1 layer otherwise
	if( (FSAAval = FSAAEnb)) {
		xlayer = open( L3Deven, O_WRONLY);
		if(xlayer < 0) {
		    printf("error: failed to open " L3Deven "\n");
		    exit( 0);
		}
		//if( ioctl(xlayer, MLC_IOCQ3DENB, (void *)1)) 
			layer3Deven = xlayer;
	
		xlayer = open( L3Dodd , O_WRONLY);
		if(xlayer < 0) {
			printf("error: failed to open " L3Dodd  "\n");
		    exit( 0);
		}
		//if( ioctl(xlayer, MLC_IOCQ3DENB, (void *)1)) 
			layer3Dodd  = xlayer;
    } else {
		xlayer = open( L3D    , O_WRONLY);
		if(xlayer < 0) {
		    printf("error: failed to open " L3D "\n");
		    exit( 0);
	    }
	//if( ioctl(xlayer, MLC_IOCQ3DENB, (void *)1)) 
		layer3D     = xlayer;
    }
#else
    fb_fd = open( FB_DEV_PATH , O_RDWR);
	if(fb_fd < 0) {
	    printf("error: failed to open " FB_DEV_PATH  "\n");
		exit( 0);
	}
#endif

    // Open 3D register set driver
    len3DE = P_3DE * psize;

    if (( fd_dev = open( DEV_NAME, O_RDWR|O_SYNC))<0) {
		perror("open " DEV_NAME " failed");
		exit(-1);
    }

    if (( fd_mem = open( MEM_NAME, O_RDWR|O_SYNC))<0) {
		perror("open " MEM_NAME " failed");
		exit(-1);
    }

    // Map 3D register set into user space
    p3DE = mmap( 0, len3DE, PROT_READ | PROT_WRITE, MAP_SHARED | MAP_LOCKED | MAP_POPULATE, fd_dev, PHYS_ADDR);
    if( (int)p3DE == -1) {
		p3DE = NULL;
		munmap( p3DE, len3DE);
		printf("mmap 0x%08x failed\n", PHYS_ADDR);
		exit(-1);
    }

    // Map 1D and 2D mem heaps
    mem1 = mmap( mem1virt, mem1size, PROT_READ | PROT_WRITE, MAP_SHARED | MAP_LOCKED | MAP_POPULATE, fd_mem, MEM1_PHYS);
    if( (int)mem1 == -1) {
		munmap( p3DE, len3DE);
		printf("mmap 0x%08x failed\n", MEM1_PHYS);
		exit(-1);
    }

    mem2 = mmap( mem2virt, mem2size, PROT_READ | PROT_WRITE, MAP_SHARED | MAP_LOCKED | MAP_POPULATE, fd_mem, MEM2_PHYS);
    if( (int)mem2 == -1) {
		munmap( p3DE, len3DE);
		munmap( mem1, mem1size);
		printf("mmap 0x%08x failed\n", MEM2_PHYS);
		exit(-1);
    }

    // Pass back mappings to ME OGL callback
    pMemoryInfomation->VirtualAddressOf3DCore	= (unsigned int)p3DE;

    pMemoryInfomation->Memory1D_VirtualAddress	= (unsigned int)mem1;
    pMemoryInfomation->Memory1D_PhysicalAddress	= MEM1_PHYS;
    pMemoryInfomation->Memory1D_SizeInMbyte	= (mem1size-0x100000) >> 20;

    pMemoryInfomation->Memory2D_VirtualAddress	= (unsigned int)mem2;
    pMemoryInfomation->Memory2D_PhysicalAddress	= MEM2_PHYS;
    pMemoryInfomation->Memory2D_SizeInMbyte	= mem2size >> 20;

    return 1;
}

void GLESOAL_Finalize( void )
{
	
	// Too late to disable 3D layer? NOT (FSAA not active)
#ifndef MLC_WIZ
	ioctl( layer3D, MLC_IOCT3DENB, 0);
	ioctl( layer3D, MLC_IOCTLAYEREN, 0);
	ioctl( layer3D, MLC_IOCTDIRTY, 1);
#else
    rgbset.enable3D = 0;
    ioctl(fb_fd, FBIO_RGB_CONTROL, &rgbset);
    
    DevEnable[0] = 0;	// layer
	DevEnable[1] = 0;	// on
	DevEnable[2] = 1;	// mlc_dev
    
    ioctl(fb_fd, FBIO_DEVICE_ENABLE, DevEnable);
    
#endif
	
	munmap( p3DE, len3DE);
    munmap( mem1, mem1size);
    munmap( mem2, mem2size);
    close(fd_mem);

    
#ifndef MLC_WIZ 
    if( FSAAval) {
		close(layer3Deven);
		close(layer3Dodd );
    } else 
    	close(layer3D);
#else
    
    close(fb_fd);

#endif  

}

//------------------------------------------------------------------------------
void GLESOAL_SwapBufferCallback( void )
{
	int layer;
	int response;
	static int once = 0;

#ifndef MLC_WIZ
    if( !once) {
		once = 1;
//		layer = open( "/dev/layer0", O_WRONLY);
		layer = layer3D;
		if(layer < 0) {
			printf("error: failed to open mlc\n");
			exit( 0);
		}

		// Enable 3D layer on 1st swap callback
		union mlc_cmd c;
		c.position.top    = 0;
		c.position.bottom = 240;
		c.position.left   = 0;
		c.position.right  = 320;
		ioctl( layer, MLC_IOCSPOSITION, (void *)&c);
		
		ioctl(layer, MLC_IOCTFORMAT, 0x4432);
		ioctl(layer, MLC_IOCTHSTRIDE, 2);
		ioctl(layer, MLC_IOCTVSTRIDE, 4096);
		ioctl(layer, MLC_IOCTLAYEREN, 1);
		ioctl(layer, MLC_IOCT3DENB, 1);
		ioctl(layer, MLC_IOCTDIRTY, 1);
	
//		close( layer);
    }
    // Hmm...The MLC layer dirty bit is not set on every callback anymore???
    else {
		//ioctl(layer, MLC_IOCTDIRTY, 1);
    }
#else
    
    rgbset.Layer = 0;
	rgbset.Addrs = 0;
	rgbset.Left = 0;
	rgbset.Top = 0;
	rgbset.Right = 320;
	rgbset.Bottom = 240;
	rgbset.HStride = 2;
	rgbset.VStride = 4096;
	rgbset.enable3D = 1;
	rgbset.Bakcol = 0x0;	
	rgbset.Mlc_dev = 1;

	ioctl(fb_fd, FBIO_RGB_CONTROL, &rgbset);
    
    DevEnable[0] = 0;	// layer
	DevEnable[1] = 1;	// on
	DevEnable[2] = 1;	// mlc_dev

	ioctl(fb_fd, FBIO_DEVICE_ENABLE, DevEnable);

#endif

}

//------------------------------------------------------------------------------
void GLESOAL_SetWindow    ( void* pNativeWindow  )
{
}

//------------------------------------------------------------------------------
void GLESOAL_GetWindowSize( int* pWidth, int* pHeight )
{
    *pWidth  = 320;
    *pHeight = 240;
}

//------------------------------------------------------------------------------
void GLESOAL_WaitForDisplayAddressPatched( void )
{
#ifndef MLC_WIZ
    if( FSAAval) {
		while( ioctl(layer3Deven, MLC_IOCQDIRTY, (void *)0));
		while( ioctl(layer3Dodd , MLC_IOCQDIRTY, (void *)0));
    } else {
    	while( ioctl(layer3D , MLC_IOCQDIRTY, (void *)0))
    		usleep(10);
    }
#else
    
    DevEnable[0] = 0;	// layer
	DevEnable[1] = 1;	// on
	DevEnable[2] = 1;	// mlc_dev
	
    while( ioctl(fb_fd, FBIO_GET_DIRTFLAG, DevEnable) ) usleep(10);

#endif

}

//------------------------------------------------------------------------------
void GLESOAL_SetDisplayAddress( const unsigned int DisplayBufferPhysicalAddress )
{

#ifndef MLC_WIZ
	// Why is this only called once? (DaveM)
    if( FSAAval) {
/*
        MES_MLC_SetFormat( LayerNumberOf3D[0], MES_MLC_RGBFMT_R5G6B5 );
        MES_MLC_SetFormat( LayerNumberOf3D[1], MES_MLC_RGBFMT_R5G6B5 );

        MES_MLC_SetRGBLayerStride( LayerNumberOf3D[0], 2, 8192 ); // HStride=2 , VStride=8192
        MES_MLC_SetRGBLayerStride( LayerNumberOf3D[1], 2, 8192 ); // HStride=2 , VStride=8192

        MES_MLC_SetRGBLayerAddress( LayerNumberOf3D[0], DisplayBufferPhysicalAddress );
        MES_MLC_SetRGBLayerAddress( LayerNumberOf3D[1], DisplayBufferPhysicalAddress+4096 );

        MES_MLC_SetAlphaBlending( LayerNumberOf3D[1], true, 8 );  // blending enable = true, alpha = 0.5

        MES_MLC_SetLayerEnable( LayerNumberOf3D[0], true );
        MES_MLC_SetLayerEnable( LayerNumberOf3D[1], true );

        MES_MLC_SetDirtyFlag( LayerNumberOf3D[0] );
        MES_MLC_SetDirtyFlag( LayerNumberOf3D[1] );  
*/
	ioctl(layer3Deven, MLC_IOCTFORMAT, VID_RGBFMT_R5G6B5);
	ioctl(layer3Dodd , MLC_IOCTFORMAT, VID_RGBFMT_R5G6B5);

	ioctl(layer3Deven, MLC_IOCTHSTRIDE, 2);
	ioctl(layer3Deven, MLC_IOCTVSTRIDE, 8192);
	ioctl(layer3Dodd , MLC_IOCTHSTRIDE, 2);
	ioctl(layer3Dodd , MLC_IOCTVSTRIDE, 8192);

	ioctl(layer3Deven, MLC_IOCTADDRESS, MEM1_PHYS); // ???
	ioctl(layer3Dodd , MLC_IOCTADDRESS, MEM1_PHYS+4096); // ???

	ioctl(layer3D, MLC_IOCTALPHA, 8);

	ioctl(layer3Deven, MLC_IOCTLAYEREN, true);
	ioctl(layer3Dodd , MLC_IOCTLAYEREN, true);

	ioctl(layer3Deven, MLC_IOCTDIRTY, (void *)1);
	ioctl(layer3Dodd , MLC_IOCTDIRTY, (void *)1);
    }
    else {
/*
        MES_MLC_SetFormat( LayerNumberOf3D, MES_MLC_RGBFMT_R5G6B5 );
        MES_MLC_SetRGBLayerStride( LayerNumberOf3D, 2, 4096 ); // HStride=2 , VStride=4096
        MES_MLC_SetRGBLayerAddress( LayerNumberOf3D, DisplayBufferPhysicalAddress );
        MES_MLC_SetLayerEnable( LayerNumberOf3D, true );
        MES_MLC_SetDirtyFlag( LayerNumberOf3D );
*/
	ioctl(layer3D, MLC_IOCTFORMAT, VID_RGBFMT_R5G6B5);

	ioctl(layer3D, MLC_IOCTHSTRIDE, 2);
	ioctl(layer3D, MLC_IOCTVSTRIDE, 4096);

//	ioctl(layer3D, MLC_IOCTADDRESS, MEM1_PHYS); // ???
	ioctl(layer3D, MLC_IOCTADDRESS, DisplayBufferPhysicalAddress); // ???
	ioctl(layer3D, MLC_IOCTLAYEREN, true);
	ioctl(layer3D, MLC_IOCTDIRTY, (void *)1);
    }
#else


    rgbset.Layer = 0;
	rgbset.Addrs = DisplayBufferPhysicalAddress;
	rgbset.Left = 0;
	rgbset.Top = 0;
	rgbset.Right = 320;
	rgbset.Bottom = 240;
	rgbset.HStride = 2;
	rgbset.VStride = 4096;
	rgbset.enable3D = 1;
	rgbset.Bakcol = 0x0;	
	rgbset.Mlc_dev = 1;

	ioctl(fb_fd, FBIO_RGB_CONTROL, &rgbset);
    
    DevEnable[0] = 0;	// layer
	DevEnable[1] = 1;	// on
	DevEnable[2] = 1;	// mlc_dev

	ioctl(fb_fd, FBIO_DEVICE_ENABLE, DevEnable);

#endif


}

//------------------------------------------------------------------------------
void GLESOAL_Sleep( unsigned long Milliseconds )
{
    if (Milliseconds == 0)
        Milliseconds = 1;
    usleep( Milliseconds*1000);
}
